# include <stdio.h>
# include <graphics.h>
/* initialization of parameters required to draw the bar graph */
# define BWIDTH 15         /* individual bar width */
# define SEP 15            /* space between the bars */
# define SHFT 10
# define DI (BWIDTH+SEP)   /* distance from the start of a bar */
			   /* to the start of the next bar */
# define WIDTH (num*DI)-SEP+DEPTH+SHFT  /* width of the bar graph */
# define LEFT 5             /* left side of the bar */
# define DEPTH 3            /* depth of the bar */
# define TOPFLAG 1          /* the 3-dimension top of the bar option is on */
# define BOT 170            /* zero level */
# define TOP 20             /* top of the frame */
# define BASE 320           /* bottom of frame */
# define PPD (float)(BOT-TOP)/max   /* pixels per data unit */


int dedomena[101];
int num,max;

main()
{
int i,driver,mode;
char ch;

ch='a';            /* initialization in order to enter the loop */
detectgraph(&driver,&mode);  /* auto driver,mode scan */
do                 /* loop for multiple run of the programme */
{
 max=1;               /* initialization */
 clrscr();            /* clear screen*/
   do
   {
   printf("Provide the number (1 to 20) of integers to be sorted:");
   scanf("%d",&num);   /* reads the number of the elements to be sorted */
   }
   while (num<1||num>20);
 printf("\nList the integers to be sorted\n");
 for (i=1;i<=num;i++)  /* loop that reads the elements to be sorted */
   {
	switch (i)   /* shows the appropriate prompt */
	{
	case 1:
	printf("Provide the 1st element:");
	break;
	case 2:
	printf("Provide the 2nd element:");
	break;
	case 3:
	printf("Provide the 3rd element:");
	break;
	default:
	printf("Provide the %dth element:",i);
	}
   scanf("%d",&dedomena[i]);    /* reads the element */
   if (abs(dedomena[i])>max)    /* find the maximum absolute value */
   max=abs(dedomena[i]);
   }
 clrscr();                               /* clear screen */
 initgraph(&driver,&mode,"f:\\tc");      /* initialize graphics */
 clrscr();                               /* clear screen */
 rectangle(LEFT,TOP-2,LEFT+WIDTH,BASE);  /* draw the frame */
 line(LEFT,BOT,LEFT+WIDTH,BOT);          /* draw zero line */
 setfillstyle(SOLID_FILL,9);          /* light blue color (for the bars) */
   for (i=1;i<=num;i++)          /* loop that draws the bars and the elements */
   {
   bar3d(LEFT+SHFT+(i-1)*DI,BOT-dedomena[i]*PPD,
	 LEFT+SHFT+(i-1)*DI+BWIDTH,BOT,DEPTH,TOPFLAG);  /* draws the bar */
   printf("%4d",dedomena[i]);                           /* shows the elements */
   }
 moveto(1,330);
 outtext("Initial array, we consider it as our current subarray (light blue bars).");
 moveto(1,340);
 outtext("Press any key to continue");
 ch=getche();            /* waits a reaction from the user */
 dedomena[num+1]=32767;  /* in the last position of the array we put a great */
			 /* value (Manolopoulos 1992).Here, we've put */
			 /* 32767 assuming that we are dealing with integers */
 quicksort(1,num);       /* call the quicksort procedure with the parameters*/
			 /* 1 and num that indicate the start and end positions */
			 /* of the elements */
 clrscr();                               /* clear screen */
 rectangle(LEFT,TOP-2,LEFT+WIDTH,BASE); /* draw the frame */
 line(LEFT,BOT,LEFT+WIDTH,BOT);
 setfillstyle(SOLID_FILL,1);           /* blue color (for the bars) */
   for (i=1;i<=num;i++)                /* loop that draws the bar graph */
   {
    bar3d(LEFT+SHFT+(i-1)*DI,BOT-dedomena[i]*PPD,    /* draws the bar */
	  LEFT+SHFT+(i-1)*DI+BWIDTH,BOT,DEPTH,TOPFLAG);
    printf("%4d",dedomena[i]);                      /* shows the respective element */
   }
 moveto(1,330);
 outtext("All the elements are sorted.");
 moveto(1,340);
 outtext("Type q to quit or press any other key to sort another set of elements.");
 ch=getche();   /* waits for user's response */
 closegraph();  /* close the graphics */
 }
 while (ch!='q'&&ch!='Q');  /* if the user responded q terminate the programme */
			   /* otherwise run it again */
}


quicksort(left,right)
{
int pivot,i,j,help,k,pivotindex;
char ch;

if (right>left)    /* proceed only if the left-right pointers  don't cross */
   {
   pivot=dedomena[left];  /* set the leftmost element of the current */
			  /* subarray as the pivot */
   pivotindex=left;       /* keep its position in the array */
   i=left;                /* pass to i,j the values of the leftmost, */
   j=right+1;             /* rightmost+1 pointers */
   while (i<j)            /* examine wether the i,j pointers cross */
       {                  /* enter the loop if they don't */
       do i++;   /* search for the leftmost element of the current subarray*/
       while (dedomena[i]<pivot);  /* that's greater or equal to pivot */
       do j--;  /* search for the rightmost element of the current subarray */
       while (dedomena[j]>pivot);   /* that's less or equal to pivot */
       if (i<j)                    /* if the indices still don't cross */
	  {
	  clrscr();                               /* clear screen */
	  rectangle(LEFT,TOP-2,LEFT+WIDTH,BASE);  /* draw frame */
	  line(LEFT,BOT,LEFT+WIDTH,BOT);          /* draw zero line */
	  for (k=1;k<=num;k++)                    /* loop that draws the bars */
	  {
	  if (k==i)   /* if k is the leftmost greater than pivot element's position*/
	     setfillstyle(SOLID_FILL,2);         /*green color*/
	     else if (k==j) /* if k is the rightmost less than pivot element's position*/
		setfillstyle(SOLID_FILL,3);     /* cyan color */
	     else if (k==pivotindex)  /* if k is pivot's position */
		setfillstyle(SOLID_FILL,4);     /* red color */
		  else if(k>=left&&k<=right) /* if k belongs to the current subarray*/
		   setfillstyle(SOLID_FILL,9);  /* light blue color */
		     else   /* if not of the above conditions is met*/
		      setfillstyle(SOLID_FILL,1); /* blue color*/
	    bar3d(LEFT+SHFT+(k-1)*DI,BOT-dedomena[k]*PPD,   /* draw the bars */
		  LEFT+SHFT+(k-1)*DI+BWIDTH,BOT,DEPTH,TOPFLAG);
	    printf("%4d",dedomena[k]);                     /* show the element*/
	   }
	  moveto(1,330);
	  outtext("We will swap the cyan and the green bars.");
	  moveto(1,340);
	  outtext("The red bar is the pivot and indicates the leftmost element of the current");
	  moveto(1,350);
	  outtext("subarray.");
	  moveto(1,360);
	  outtext("The green bar indicates the leftmost element that is greater than pivot.");
	  moveto(1,370);
	  outtext("The cyan bar indicates the rightmost element that is less than pivot.");
	  moveto(1,380);
	  outtext("Press any key to continue");
	  setfillstyle(SOLID_FILL,1);  /* blue color */
	  ch=getche();                 /* wait for the user to respond */
	  help=dedomena[j];            /* update the array, swapping the elements */
	  dedomena[j]=dedomena[i];     /* you located above*/
	  dedomena[i]=help;
	  }
	}                                  /* end while*/
					   /* if the pointers cross*/
    clrscr();                              /* clear screen */
    rectangle(LEFT,TOP-2,LEFT+WIDTH,BASE); /* draw frame  */
    line(LEFT,BOT,LEFT+WIDTH,BOT);         /* draw zero line */
    for (k=1;k<=num;k++)               /*  loop that draws the bar graph*/
    {
    if (k==pivotindex)  /* if k is the pivot's position*/
    setfillstyle(SOLID_FILL,4);                       /* red color */
      else if (k>=left&&k<=right)   /* if k belongs to the current subarray */
      setfillstyle(SOLID_FILL,9);                     /* light blue color*/
	else                                          /* otherwise */
	 setfillstyle(SOLID_FILL,1);                  /* blue color */
      bar3d(LEFT+SHFT+(k-1)*DI,BOT-dedomena[k]*PPD,   /* draw the bar */
	    LEFT+SHFT+(k-1)*DI+BWIDTH,BOT,DEPTH,TOPFLAG);
      printf("%4d",dedomena[k]);                     /* show the element */
    }
    moveto(1,330);
    outtext("The indices cross,we will swap the pivot (red bar) with the rightmost element");
    moveto(1,340);
    outtext("of the current subarray (lightblue bars) that is less or equal to pivot.");
    moveto(1,350);
    outtext("Press any key to continue");
    setfillstyle(SOLID_FILL,1);      /* blue color */
    ch=getche();                     /* wait for the user to respond */
    help=dedomena[j];               /* update the array, swapping the pivot */
    dedomena[j]=dedomena[left];     /* with the leftmost element of the current */
    dedomena[left]=help;            /* subaaray that's less or equal to pivot*/
    quicksort(left,j-1);            /* sort the left subarray */
    quicksort(j+1, right);          /* sort the right subarray */
    }
}